#include<basic.h>
#include<btron/libapp.h>
#include<tcode.h>
#include<tstring.h>
#include<btron/dp.h>
#include<btron/vobj.h>
#include<btron/clk.h>
#include<bstdlib.h>
#include<bstring.h>
#include<errcode.h>
extern VOBJSEG vseg;

void dragvobjandpaste(W wid, RECT vr, VLINK *vlnk, W errno)
{
    W i, did, pwid, gid2;
    SEL_RGN selp;
    WEVENT evt;
    PNT pos, posbak, zure, pnt;
    TR_VOBJREC vrec;
    TRAYREC trec;
    FIGSEG tsfig;
    B *pt, *pt2;
    RECT r;

    /* $B%I%i%C%0IA2h4D6-$r<hF@(B */
    did = wsta_drg(wid, 1);
    /* $B2hLL$r$O$_=P$9>l9g$N=hM}(B */
    gget_fra(did, &r);
    gset_vis(did, r);
    /* $BOH$NBg$-$5$H!"DO$s$@0LCV$K$h$kJd@5%G!<%?$N<hF@(B */
    selp.rgn.r = vr;
    zure.x = wevt.s.pos.x - selp.rgn.r.c.left;
    zure.y = wevt.s.pos.y - selp.rgn.r.c.top;
    selp.sts = 0x0020;
    /* $B%]%$%s%?$r0.$j$N7A$X(B */
    gset_ptr(PS_GRIP, NULL, -1, -1);	
    while (1) {
	/* PD$B$N%\%?%s$r2!$7$F$$$k4V$N%I%i%C%00\F0=hM}(B */
	if (wget_drg(&pos, &evt) == EV_BUTUP) {
	    gcnv_abs(did, &pos);
	    break;
	}
	if (pos.x == posbak.x && pos.y == posbak.y)
	    adsp_sel(did, &selp, -1);
	else { 	    /* $BA0$N0LCV$h$jF0$$$F$$$l$PIA2h$9$k(B */
	    posbak = pos;
	    pos.x -= zure.x;
	    pos.y -= zure.y;
	    adsp_sel(did, &selp, 0);
	    posrect(&selp.rgn.r, pos);
	    adsp_sel(did, &selp, 1);
	}
    }
    adsp_sel(did, &selp, 0);
    /* $B%I%i%C%0=hM}=*N;(B */
    wend_drg();
    /* $B%]%$%s%?$N2<$K$"$k%&%#%s%I%&(BID$B$r<hF@(B */
    wfnd_wnd(&pos, NULL, &pwid);
    /* $B<+J,$N%&%#%s%I%&$G$J$1$l$P$=$3$K%"%W%j%1!<%7%g%s%U%!%$%k$N(B
       $B2>?H$rD%$jIU$1$k(B */
    if (pwid && (pwid != wid)) {
	/* $B2>?H$N%G!<%?$r5-=R(B */
	trec.id = 0x0001;
	trec.len = sizeof(TR_VOBJREC);
	trec.dt = (B*)&vrec;
	pt = (B *)vlnk;
	pt2 = (B *)&(vrec.vlnk);
	for (i = 0 ; i < sizeof(VLINK) ; i++) {
	    *(pt2++) = *(pt++);
	}
	gid2 = wget_gid(pwid);
	pnt.x = pnt.y = 0;
	gcnv_abs(gid2, &pnt);

	vrec.vseg.view.c.left = pos.x - pnt.x - zure.x;
	vrec.vseg.view.c.top = pos.y - pnt.y - zure.y;
	vrec.vseg.view.c.right = pos.x + vr.c.right - vr.c.left
					 - pnt.x - zure.x;
	vrec.vseg.view.c.bottom = pos.y + vr.c.bottom - vr.c.top
					  - pnt.y - zure.y;
	vrec.vseg.height = vseg.height;
	vrec.vseg.chsz = vseg.chsz;
	vrec.vseg.frcol = vseg.frcol;
	vrec.vseg.chcol = vseg.chcol;
	vrec.vseg.tbcol = vseg.tbcol;
	vrec.vseg.bgcol = vseg.bgcol;
	vrec.vseg.dlen = vseg.dlen;
	/* $B0l;~%H%l!<$X2>?H$N%G!<%?$rF~$l$k(B */
	tset_dat(&trec, 1);
	/* $BD%$jIU$1%$%Y%s%H$rD%$jIU$1$k%&%#%s%I%&$KAw$k(B */
	evt.r.type = EV_REQUEST;
	evt.r.cmd = W_PASTE;
	evt.r.wid = pwid;
	evt.s.pos.x = evt.s.pos.y = 0;
	evt.r.src = prc_sts(0, NULL, NULL);
	/* $B%$%Y%s%H$NAw?.(B */
	wsnd_evt(&evt);
	/* W_ACK$B$,JV$C$FMh$J$$>l9g$O$=$N%&%#%s%I%&$KD%$jIU$1$k(B
	   $B$3$H$O=PMh$J$$(B */
	if (wwai_rsp(&evt, W_PASTE, 60000) != W_ACK) {
	    printerror(errno);
	    return;
	}
	/* $BE=$jIU$1$?%&%#%s%I%&$r%"%/%F%#%V$K$9$k(B */
	wswi_wnd(pwid, NULL);
    }
}


